<template>
  <div id="class_index_wrapper">
    <div>
      <el-table class="elTable" :data="page" style="width: 100%">
        <el-table-column :label="$t('LECTURE_LIST.NUMBER')" width="100">
          <template slot-scope="scope">
            {{ (pageNum - 1) * 10 + (scope.$index + 1) }}
          </template>
        </el-table-column>
        <el-table-column prop="name" :label="$t('TEACHER_CLASS.COURSE')" />
        <el-table-column prop="master.name" :label="$t('STUDENT_MENU.INSTRUCTOR')" width="150" />
        <el-table-column :label="$t('TEACHER_CLASS.PERIOD')">
          <template slot-scope="scope">
            {{ scope.row.start_time ? new Date(scope.row.start_time).toLocaleDateString('ko-KR') : $t('TEACHER_CLASS.UNDECIDED') }}
            ~
            {{ scope.row.end_time ? new Date(scope.row.end_time).toLocaleDateString('ko-KR') : $t('TEACHER_CLASS.UNDECIDED') }}
          </template>
        </el-table-column>
        <el-table-column label="" header-align="left" align="right" width="150">
          <template slot-scope="scope">
            <!--
            <el-button type="success" @click="onClick('DETAIL', scope.row)">살펴보기</el-button>
            -->
            <el-button type="primary" v-if="scope.row.opened !== 2" @click="onClick('LISTEN', scope.row)">{{ $t('STUDENT_MENU.TAKE_LECTURE') }}</el-button>
          </template>
        </el-table-column>
        <el-table-column label="" header-align="left" align="right" width="150">
          <template slot-scope="scope">
            <el-button type="primary" v-if="scope.row.opened !== 2" @click="onClick('CANCEL_PREVIEW', scope.row)">{{ $t('STUDENT_MENU.CANCEL_PREVIEW') }}</el-button>
          </template>
        </el-table-column>
      </el-table>
      <br>
    </div>
    <div id="pagination" style="display: block; text-align: center;">
      <el-pagination
        background
        layout="prev, pager, next"
        :total="listCount"
        :current-page.sync="pageNum"
      />
    </div>
    <br>
    <div style="display: block; text-align: center;">
      <el-select v-model="searchQuery.searchType" style="display: inline-block; width: 100px">
        <el-option
          v-for="option in selectOptionList"
          :key="option.value"
          :label="option.label"
          :value="option.value">
        </el-option>
      </el-select>
      <el-input style="display: inline-block; width: 300px" :placeholder="$t('STUDENT_MENU.ENT_SEARCH_TERM')"
        v-model="searchQuery.searchText" @keydown.enter.native="onClick('SEARCH', searchQuery)"></el-input>
      <el-button @click="onClick('SEARCH', searchQuery)" icon="el-icon-search" circle></el-button>
    </div>
  </div>
</template>

<script>
import utils from '../../utils';

export default {
  name: 'StudentClassTable',
  props: ['list', 'onClick'],
  data() {
    return {
      pageNum: 1,
      selectOptionList: [
        {
          value: 'name',
          label: this.$t('TEACHER_CLASS.COURSE'),
        },
        {
          value: 'teacher',
          label: this.$t('STUDENT_MENU.INSTRUCTOR'),
        },
      ],
      searchQuery: {
        searchType: 'name',
        searchText: '',
      },
    };
  },
  computed: {
    listCount() {
      return this.list.length;
    },
    page() {
      const vm = this;
      return vm.list.slice((vm.pageNum - 1) * 10, vm.pageNum * 10);
    },
  },
  created() {
    const vm = this;
    if (vm.$route.query.type !== undefined) {
      vm.searchQuery.searchType = vm.$route.query.type;
    }
    if (vm.$route.query.text !== undefined) {
      vm.searchQuery.searchText = vm.$route.query.text;
    }
  },
  methods: {
    formatDate: utils.formatDate,
  },
};
</script>


<style lang="scss" scoped>
#class_index_wrapper {
  .elTable-label {
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .elTable-label tr {
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .elTable-label td {
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #606266;
  }
}
</style>
